import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "nOVQPOOO[QPO'#C`QOQPOOOaQPO,58zOOQO1G.f1G.f",
  stateData: "f~OWOS~ORPO~OTRO~OQSO~O",
  goto: "XTPPPPURQO",
  nodeNames: "⚠ Program } { SyntaxNode Identifier",
  maxTerm: 8,
  nodeProps: [
    ["openedBy", 2,"{"],
    ["closedBy", 3,"}"]
  ],
  skippedNodes: [0],
  repeatNodeCount: 0,
  tokenData: "!i~RXXYnYZn]^npqn!c!}!P#R#S!P#T#o!P#o#p!_#q#r!d~sSW~XYnYZn]^npqn~!URT~!c!}!P#R#S!P#T#o!P~!dOR~~!iOQ~",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 0
});

const RomeAstLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({}),
            foldNodeProp.add({
                SyntaxNode: foldInside,
            }),
            styleTags({
                Identifier: tags.variableName,
                String: tags.string,
                "( )": tags.paren
            }),
        ],
    }),
    languageData: {
        closeBrackets: { brackets: ["[", "{", '"', ')'] },
    },
});
function romeAst() {
    console.log(parser.parse(`
  
JsVariableStatement {
    declaration: JsVariableDeclaration {
        kind: LET_KW@0..4 "let" [] [Whitespace(" ")],
        declarators: JsVariableDeclaratorList [
            JsVariableDeclarator {
                id: JsIdentifierBinding {
                    name_token: IDENT@4..6 "a" [] [Whitespace(" ")],
                },
                variable_annotation: missing (optional),
                initializer: JsInitializerClause {
                    eq_token: EQ@6..8 "=" [] [Whitespace(" ")],
                    expression: JsNumberLiteralExpression {
                        value_token: JS_NUMBER_LITERAL@8..9 "3" [] [],
                    },
                },
            },
        ],
    },
    semicolon_token: SEMICOLON@9..10 ";" [] [],
}
  `));
    return new LanguageSupport(RomeAstLanguage, []);
}

export { RomeAstLanguage, romeAst };
